'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SVGPrev = require('./svg/SVGPrev');

var _SVGPrev2 = _interopRequireDefault(_SVGPrev);

var _SVGNext = require('./svg/SVGNext');

var _SVGNext2 = _interopRequireDefault(_SVGNext);

var _recompose = require('recompose');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _RTGCSSTransitionFade = require('./RTGCSSTransitionFade');

var _RTGCSSTransitionFade2 = _interopRequireDefault(_RTGCSSTransitionFade);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _helperFunctions = require('./helperFunctions');

var _ = require('.');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var interval = void 0;

var getContainerElement = function getContainerElement(_ref) {
  var props = _ref.props;
  var containerClass = props.containerClass,
      containerRef = props.containerRef,
      containerId = props.containerId;

  return (0, _helperFunctions.getElement)({ ref: containerRef, className: containerClass, id: containerId, debug: false });
};

var Accordion = function (_React$Component) {
  (0, _inherits3.default)(Accordion, _React$Component);

  function Accordion() {
    var _ref2,
        _this2 = this;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Accordion);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = Accordion.__proto__ || (0, _getPrototypeOf2.default)(Accordion)).call.apply(_ref2, [this].concat(args))), _this), _this.handleScroll = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      var _this$props, leeway, setShowLeft, setShowRight, showLog, containerElement;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this$props = _this.props, leeway = _this$props.leeway, setShowLeft = _this$props.setShowLeft, setShowRight = _this$props.setShowRight, showLog = _this$props.showLog;
              containerElement = getContainerElement({ props: _this.props });
              _context.next = 4;
              return (0, _helperFunctions.delay)(500);

            case 4:

              showLog && console.log('// handleScroll // ', 'containerElement.scrollLeft + leeway: ', containerElement.scrollLeft + leeway, 'scrollWidth: ', containerElement.scrollWidth, 'clientWidth: ', containerElement.clientWidth, 'diff: ', containerElement.scrollWidth - containerElement.clientWidth);

              if (!(containerElement.scrollLeft === 0 || containerElement.scrollWidth === containerElement.clientWidth)) {
                _context.next = 11;
                break;
              }

              _context.next = 8;
              return setShowLeft(false);

            case 8:
              clearInterval(interval);
              _context.next = 14;
              break;

            case 11:
              if (!(containerElement.scrollLeft > 0)) {
                _context.next = 14;
                break;
              }

              _context.next = 14;
              return setShowLeft(true);

            case 14:
              if (!(containerElement.scrollLeft + leeway >= containerElement.scrollWidth - containerElement.clientWidth || containerElement.scrollWidth === containerElement.clientWidth)) {
                _context.next = 20;
                break;
              }

              _context.next = 17;
              return setShowRight(false);

            case 17:
              clearInterval(interval);
              _context.next = 23;
              break;

            case 20:
              if (!(containerElement.scrollWidth >= containerElement.clientWidth)) {
                _context.next = 23;
                break;
              }

              _context.next = 23;
              return setShowRight(true);

            case 23:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this2);
    })), _this.renderNav = function (direction) {
      var _this$props2 = _this.props,
          showLog = _this$props2.showLog,
          height = _this$props2.height,
          width = _this$props2.width,
          showLeft = _this$props2.showLeft,
          showRight = _this$props2.showRight,
          renderButton = _this$props2.renderButton;

      showLog && console.log('this.props: ', _this.props);

      var containerElement = getContainerElement({ props: _this.props });
      showLog && console.log('containerElement: ', containerElement);

      var autoHeight = containerElement && containerElement.clientHeight;
      var autoWidth = 18;

      var startScroll = function startScroll(e) {
        e.stopPropagation();
        clearInterval(interval);

        if (containerElement) {
          interval = setInterval(function () {
            return direction === 'left' ? containerElement.scrollLeft -= 20 : containerElement.scrollLeft += 20;
          }, 50);
        }
      };
      var endScroll = function endScroll(e) {
        e.stopPropagation();
        clearInterval(interval);
      };

      var SVGProps = {
        fill: '#555',
        size: width ? width : autoWidth
      };

      return _react2.default.createElement(
        _RTGCSSTransitionFade2.default,
        {
          style: { width: width ? width : autoWidth, height: height ? height : autoHeight },
          'in': direction === 'left' ? showLeft : showRight
        },
        function (_ref4) {
          var rtgStyle = _ref4.style;

          var getButtonProps = function getButtonProps() {
            var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            var style = _ref5.style,
                colors = _ref5.colors,
                props = (0, _objectWithoutProperties3.default)(_ref5, ['style', 'colors']);
            return {
              onMouseDown: startScroll,
              onMouseUp: endScroll,
              onTouchStart: startScroll,
              onTouchEnd: endScroll,
              className: 'accordion accordion--' + direction,
              colors: colors ? colors : _.buttonStyles.violet,
              style: (0, _extends3.default)({}, rtgStyle, { height: (height ? height : autoHeight) + 'px', padding: 0 })
            };
          };
          return renderButton ? renderButton({ getButtonProps: getButtonProps, direction: direction }) : _react2.default.createElement(
            _Button2.default,
            (0, _extends3.default)({}, getButtonProps()),
            _react2.default.createElement(
              'div',
              { style: { background: '#fff' } },
              direction === 'left' ? _react2.default.createElement(_SVGPrev2.default, SVGProps) : _react2.default.createElement(_SVGNext2.default, SVGProps)
            )
          );
        }
      );
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Accordion, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.handleScroll();
      var containerElement = getContainerElement({ props: this.props });
      containerElement.addEventListener('scroll', this.handleScroll);
      window.addEventListener('resize', this.handleScroll);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      prevProps.children !== this.props.children && this.handleScroll(); // numberOfItems => children.length
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearInterval(interval);
      var containerElement = getContainerElement({ props: this.props });
      containerElement.removeEventListener('scroll', this.handleScroll);
      window.removeEventListener('resize', this.handleScroll);
    }
  }, {
    key: 'render',
    value: function render() {
      return typeof window !== 'undefined' && _react2.default.createElement(
        _react2.default.Fragment,
        null,
        this.renderNav('left'),
        this.props.children,
        this.renderNav('right')
      );
    }
  }]);
  return Accordion;
}(_react2.default.Component);

Accordion.defaultProps = {
  showLog: false,
  leeway: 0
};

Accordion.propTypes = (0, _defineProperty3.default)({
  containerClass: _propTypes2.default.string,
  leeway: _propTypes2.default.number,
  width: _propTypes2.default.number,
  showLeft: _propTypes2.default.bool.isRequired,
  showRight: _propTypes2.default.bool.isRequired,
  setShowLeft: _propTypes2.default.func.isRequired
}, 'setShowLeft', _propTypes2.default.func.isRequired);

var enhance = (0, _recompose.compose)((0, _recompose.withState)('showLeft', 'setShowLeft', false), (0, _recompose.withState)('showRight', 'setShowRight', false), (0, _recompose.onlyUpdateForKeys)(['showLeft', 'showRight', 'children', 'containerRef']));

exports.default = enhance(Accordion);