'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultStyles = exports.buttonStyles = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helperFunctions = require('./helperFunctions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buttonStyles = exports.buttonStyles = {
  vivid: {
    transition: 'smooth',
    on: { background: '#33aaff', color: '#eeeeee' },
    off: { background: '#ffbb33', color: '#333333' },
    diff: 25
  },
  neutral: {
    transition: 'background',
    on: { background: '#bbbbbb' },
    off: { background: '#ffffff' },
    disabled: { background: '#ccc', color: '#888' },
    diff: 30
  },
  link: { on: { color: '#888888' }, off: { color: '#222222' }, transition: 'text', diff: 20 },
  vampire: {
    on: { background: '#bb2222', color: '#eeeeee' },
    off: { background: '#e4e4e4', color: '#333333' },
    diff: 20,
    transition: 'smooth'
  },
  redden: {
    on: { background: '#dd8888', color: '#eeeeee' },
    off: { background: 'none', color: '#333333' },
    diff: 25,
    transition: 'contrast'
  },
  verdant: {
    on: { background: '#88dd88', color: '#eeeeee' },
    off: { background: 'none', color: '#333333' },
    diff: 20,
    transition: 'contrast'
  },
  traffic: {
    on: { background: '#dd3333', color: '#eeeeee' },
    off: { background: '#33dd33', color: '#333333' },
    diff: 20,
    transition: 'contrast'
  },
  violet: {
    on: { background: '#dd33dd88', color: '#eeeeee' },
    off: { background: '#cc88cc88', color: '#eeeeee' },
    diff: 25,
    transition: 'smooth'
  },
  delphiniumC: {
    on: { background: '#dd33dd88', color: '#111' },
    off: { background: '#ffffff', color: '#111' },
    diff: 25,
    transition: 'contrast'
  },
  delphiniumS: {
    on: { background: '#dd33dd88', color: '#111' },
    off: { background: '#ffffff', color: '#111' },
    diff: 25,
    transition: 'smooth'
  },
  delphiniumM: {
    on: { background: '#dd33dd88', color: '#111' },
    off: { background: '#ffffff', color: '#111' },
    diff: 25,
    transition: 'mix'
  },
  lisanthus: {
    on: { background: '#591b64', color: '#eee' },
    off: { background: '#ffffff', color: '#414' },
    diff: 25,
    transition: 'mix'
  },
  darken: {
    on: { background: '#bbbbbb', color: '#eeeeee' },
    off: { background: 'none', color: '#333333' },
    diff: 20,
    transition: 'contrast'
  },
  monochrome: {
    on: { background: '#333333', color: '#f4f4f4' },
    off: { background: '#fafafa', color: '#333333' },
    diff: 20,
    transition: 'smooth'
  },
  mild: {
    on: { background: '#eeffff', color: '#111111' },
    off: { background: '#fafafa', color: '#333333' },
    diff: 10,
    transition: 'smooth'
  }
};

var defaultStyles = exports.defaultStyles = {
  container: {
    position: 'relative',
    alignItems: 'center',
    cursor: 'default',
    display: 'flex',
    flex: '0 1 auto',
    flexDirection: 'column',
    margin: '0 1rem',
    opacity: '1',
    color: 'black',
    background: 'rgba(245, 245, 245, 0.85)',
    border: '1px solid #575757',
    zIndex: '2',
    borderRadius: '0.5rem'
  },
  body: {
    display: 'flex',
    flexDirection: 'column',
    background: '#fdfdfd',
    flex: '1 1 auto',
    padding: '2.4rem 1.2rem',
    borderRadius: '0 0 1rem 1rem',
    overflowY: 'auto'
  },
  background: {
    position: 'fixed',
    height: '100%',
    top: '0',
    left: '0',
    width: '100%',
    background: 'rgba(0, 0, 0, 0.5)',
    zIndex: '4',
    opacity: '1',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    WebkitTapHighlightColor: 'transparent'
  },
  header: {
    margin: '0',
    padding: '2rem 2rem 1.5rem 2rem',
    borderBottom: '0.5rem solid #f0f0f0',
    background: '#fafafa'
  },
  buttons: {
    borderTop: '1px solid #575757',
    padding: '0.5rem 0',
    width: '100%',
    background: 'white',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'flex-end'
  },
  closemodalbutton: {
    top: '0.5rem',
    right: '0.5rem',
    cursor: 'pointer',
    position: 'absolute',
    background: 'white',
    borderRadius: '100%',
    display: 'flex',
    flexDirection: 'row-reverse'
  }
};